﻿namespace LDBproject.Entities;

public class Order
{
    public int OrderID { get; private set; }

    public int CardID { get; private set; }

    public int LibrarianID { get; private set; }

    public DateTime BorrowDate { get; private set; }

    public IEnumerable<Registration> Registrations { get; set; } = [];

    public static Order NewOrder(
        int orderIndex, int ticketIndex, int librarian, IEnumerable<Registration> list, DateTime borrow)
    {
        return new Order
        {
            OrderID = orderIndex,
            CardID = ticketIndex,
            LibrarianID = librarian,
            Registrations = list,
            BorrowDate = borrow
        };
    }

    public static Order NewOrder(TemprOrderReg order, IEnumerable<Registration> regs)
    {
        return new Order
        {
            OrderID = order.OrderID,
            CardID = order.CardID,
            LibrarianID = order.LibrarianID,
            Registrations = regs,
            BorrowDate= order.BorrowDate
        };
    }
}
