using LDBproject.AdditionalForms;
using Unity;

namespace LDBproject;

public partial class MainForm : Form
{
    private readonly IUnityContainer _container;

    public MainForm(IUnityContainer container)
    {
        InitializeComponent();
        _container = container ??
            throw new ArgumentNullException(nameof(container));
    }

    private void EmployeeCard_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<EmployeesF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : mistake ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void ReaderCard_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<CustomerListF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : mistake ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void BookReg_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<BookListF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : mistake ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void GiveOut_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<OrdersF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : mistake ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void Updating_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<UpdatesListF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : mistake ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void Report_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FullReportsF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : ERROR ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void OrderReport_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<OrdersReportF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : ERROR ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void UpdReport_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<UpdReportF>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "[ Download : ERROR ]",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}
